<?php

/*******************************************************************
* steamcast.class.php
* Version: 1.0
* Author: W. Herrmann
* Copyright (C) 2009, SC-Tools
*******************************************************************/

class SteamCast {

   // Public
   var $host;
   var $port;
   var $user;
   var $passwd;

   //Private
   var $_xml;
   var $_error;
   var   $_currentListeners;
   var   $_streamStatus;
   var   $_peakListeners;
   var   $_maxListeners;
   var   $_reportedListeners;
   var   $shoutcast;



   function openStats() {

      $fp = @fsockopen($this->host, $this->port, $errno, $errstr, 10);


      if (!$fp) {
         $this->_error = "$errstr ($errno) - $this->port";
         return(0);

      } else {

         // grab XML stats
         stream_set_timeout($fp, 2);
         $status = null;
         $status = socket_get_status($fp);




         fputs($fp, "GET /admin/status.xml HTTP/1.1\r\n");
         fputs($fp, "Authorization: Basic ".base64_encode ($this->user.':'.$this->passwd)."\r\n\r\n");


            while (!feof($fp) && !$status['timed_out']) {
            $line = trim(fgets($fp, 512));
            $this->_xml .= (empty($line)) ? null : $line;
            $status = socket_get_status($fp);
          }

         $this->_xml = preg_replace("/^HTTP(.*?)xml/", "", $this->_xml);

          fclose($fp);


         $xmlparser = xml_parser_create();
         if (!xml_parse_into_struct($xmlparser, $this->_xml, $this->_values, $this->_indexes)) {
            $this->_error = "Unparsable XML";
            echo $this->_xml;
            return(0);
         }

         xml_parser_free($xmlparser);

         return(1);
      }


   }

   function getStartupTime() {
      return($this->_values[$this->_indexes["STARTUP_TIME"][0]]["value"]);
   }

   function getSystemTime() {
      return($this->_values[$this->_indexes["SYSTEM_TIME"][0]]["value"]);
   }

   function getCurrentListenersCount() {
      return ($this->_currentListeners) ? $this->_currentListeners : $this->_values[$this->_indexes["TOTAL_NODES"][0]]["value"];
   }

   function getPeakListenersCount() {
      return ($this->_peakListeners) ? $this->_peakListeners : $this->_values[$this->_indexes["TOTAL_PEAK_NODES"][0]]["value"];
   }

   function getMaxListenersCount() {
      return ($this->_maxListeners) ? $this->_maxListeners : $this->_values[$this->_indexes["TOTAL_MAX_NODES"][0]]["value"];
   }

   function getUniqueListenersCount() {
      return ($this->_reportedListeners) ? $this->_reportedListeners : $this->_values[$this->_indexes["TOTAL_UNIQUE_NODES"][0]]["value"];
   }

   function getAverageListenTime() {
      return($this->_values[$this->_indexes["TOTAL_AVERAGE_CONNECT_TIME"][0]]["value"]);
   }

   function getServerGenre() {
      return($this->_values[$this->_indexes["GENRE"][0]]["value"]);
   }

   function GetMetaURL() {
      return($this->_values[$this->_indexes["META_URL"][0]]["value"]);
   }

   function GetServerURL() {
      return($this->_values[$this->_indexes["URL"][0]]["value"]);
   }

   function getServerTitle() {
      return($this->_values[$this->_indexes["NAME"][0]]["value"]);
   }

   function getCurrentSongTitle() {
      return($this->_values[$this->_indexes["META_SONG"][0]]["value"]);
   }

   function getContentType() {
      return($this->_values[$this->_indexes["CONTENT_TYPE"][0]]["value"]);
   }

   function getContentBackup() {
      return($this->_values[$this->_indexes["BACKUP"][0]]["value"]);
   }

   function getStreamHitsCount() {
      return($this->_values[$this->_indexes["TOTAL_TUNEINS"][0]]["value"]);
   }

   function getStreamStatus() {
      return (isset($this->_streamStatus)) ? $this->_streamStatus : $this->_values[$this->_indexes["STATUS"][0]]["value"];
   }

   function getWebHitsCount() {
      return($this->_values[$this->_indexes["TOTAL_TUNEINS"][0]]["value"]);
   }

   function getBitRate() {
      return (isset($this->_bitrate)) ? round($this->_bitrate) : round($this->_values[$this->_indexes["BITRATE"][0]]["value"]);
   }

   function getBytesSent() {
      return($this->_values[$this->_indexes["BYTES_SENT"][0]]["value"]);
   }

   function getBytesRecv() {
      return($this->_values[$this->_indexes["BYTES_RECV"][0]]["value"]);
   }

   function GetSongHistory() {
                for($i=1;$i<sizeof($this->_indexes['SONG_TITLE']);$i++) {
                        $arrhistory[$i-1] = array(
                        "entry_time"=>$this->_values[$this->_indexes['ENTRY_TIME'][$i]]['value'],
                        "song_title"=>$this->_values[$this->_indexes['SONG_TITLE'][$i]]['value']);
                }

                return($arrhistory);
        }

   function GetListeners() {
      for($i=0;$i<sizeof($this->_indexes['USER_AGENT']);$i++) {
           $arrlisteners[$i] = array(
           "pbytes_sent"=>$this->_values[$this->_indexes['PBYTES_SENT'][$i]]['value'],
           "nid"=>$this->_values[$this->_indexes['NID'][$i]]['value'],
           "ip"=>$this->_values[$this->_indexes['IP'][$i]]['value'],
           "user_agent"=>$this->_values[$this->_indexes['USER_AGENT'][$i]]['value'],
           "underruns"=>$this->_values[$this->_indexes['UNDERRUNS'][$i]]['value'],
           "pbandwidth"=>$this->_values[$this->_indexes['PBANDWIDTH'][$i]]['value'],);


                }

                return($arrlisteners);
        }

        function geterror() { return($this->_error); }
}

?>